﻿using System;
using System.Collections.Generic;
using System.Linq;
using NLog;

namespace LogsPractice.Models
{
    public class Student
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public int Age { get; set; }
    }

    public class StudentsRepository
    {
        private static Logger logger = LogManager.GetCurrentClassLogger();

        //записи находятся в базе данных
        private readonly List<Student> _studentsList = new List<Student>()
        {
            new Student() { Id = 1, Name = "George", Age = 19 },
            new Student() { Id = 2, Name = "John", Age = 22 },
            new Student() { Id = 3, Name = "Mark", Age = 14 }
        };

        public List<Student> GetStudents()
        {
            logger.Debug("Произведено подключение к базе данных.");
            logger.Debug("Произведена выборка всех студентов");
            return _studentsList;
        }

        public Student GetStudentById(int id)
        {
            logger.Trace("Запрашиваемый id студента: " + id);
            logger.Trace("Попытка подключения к источнику данных");
            logger.Trace("Подключение прошло успешно. Затраченное время (мс): " + new TimeSpan(0,0,0,0,20).Milliseconds);
            var student = _studentsList.FirstOrDefault(x => x.Id == id);
            if(student == null)
                logger.Error("Ошибка. Не найден студент с таким id: " + id);
            if(student.Age < 15)
                logger.Warn("Выбран студент моложе 15 лет");
            logger.Trace("Выборка прошла успешно. Выбран студент с id == " + student.Id);
            return student;
        }
    }
}